﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using SlimDX;
using SlimDX.DirectInput;

namespace PolledDevices
{
    /// <summary>
    /// 
    /// </summary>
    public class PolledMouseEventArgs : System.EventArgs
    {
        /// <summary>
        /// 
        /// </summary>
        public SlimDX.DirectInput.MouseState State;
        
        /// <summary>
        /// 
        /// </summary>
        public int Button;
        
        /// <summary>
        /// 
        /// </summary>
        public Point ClientPos;
        
        /// <summary>
        /// 
        /// </summary>
        public Point ScreenPos;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="s"></param>
        /// <param name="client"></param>
        /// <param name="screen"></param>
        public PolledMouseEventArgs(MouseState s, Point client, Point screen)
            : this(s, client, screen, -1)
        {
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="s"></param>
        /// <param name="client"></param>
        /// <param name="screen"></param>
        /// <param name="button"></param>
        public PolledMouseEventArgs(MouseState s, Point client, Point screen, int button)
        {
            this.State = s;
            this.ClientPos = client;
            this.ScreenPos = screen;
            this.Button = button;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public delegate void PolledMouseEventHandler(object sender, PolledMouseEventArgs e);
}
